#ifndef _OPENDRIVE_PARAMPOLY3_H
#define _OPENDRIVE_PARAMPOLY3_H

#include "opendrive_geometry.h"

typedef struct
{
  double a;
  double b;
  double c;
  double d;
}TOpendrivePoly3Params;

class COpendriveParamPoly3 : public COpendriveGeometry
{
  friend class COpendriveRoadNode;
  friend class COpendriveRoadSegment;
  private:
    TOpendrivePoly3Params u;
    TOpendrivePoly3Params v;
    bool normalized;
  protected:
    COpendriveParamPoly3();
    COpendriveParamPoly3(const COpendriveParamPoly3 &object);
    virtual bool transform_local_pose(const TOpendriveTrackPose &track,TOpendriveLocalPose &local) const;
    virtual void print(std::ostream &out);
    virtual void load_params(const planView::geometry_type &geometry_info);
    virtual std::string get_name(void);
  public:
    virtual COpendriveGeometry *clone(void);
    virtual void get_curvature(double &start,double &end);
    TOpendrivePoly3Params get_u_params(void);
    TOpendrivePoly3Params get_v_params(void);
    bool is_normalized(void);
    void operator=(const COpendriveParamPoly3 &object);
    ~COpendriveParamPoly3();
};

#endif
